#!/usr/bin/perl

$VER = '0.3.12';

## Create CertificateDB - Version $VER
## (c) 1999 by Massimiliano Pala 
## OpenCA Core Team
##
## (OpenCA Project)
##
## Description:
## ============
##
## This program creates a DB of the certificates where the
## ca program will look for certificates. You need to run
## this script BEFORE starting the CA only when you issue
## certificate through the scritps in the bin/ directory and
## not using the Web interface.
##
## The DB structure is very simple, every entry looks like
## the following :
##
##	$serial => $certificate
##
## Please take note that this program, if the DB is not present
## will create it: you must be sure you run it as the user the
## httpd server will run (as the ca program needs to access to
## the DB to properly work). If permissions are not set, please
## change them or rebuild the DB (delete it and use this prog.)
##
## For Any clarifications, please refer to:
##
##	o Documentation;
##	o openca-devel@openca.org;
##
## 14 Apr 2000 - Addedd support for OpenCA::DB module.
##               Massimiliano Pala (madwolf@openca.org)

$DIR = $ARGV[0];
$SERVER = $ARGV[1];

my @dbList = ();
my $DB_FILE;

if( -f "$DIR/dB/issued_certs.db" ) {
	link("$DIR/dB/issued_certs.db","$DIR/dB/valid_certs.db");
	unlink( "$DIR/dB/issued_certs.db" );
}

push @dbList, "$DIR/dB/ca_certs";
push @dbList, "$DIR/dB/expired_ca_certs";

push @dbList, "$DIR/dB/valid_certs";
push @dbList, "$DIR/dB/revoked_certs";
push @dbList, "$DIR/dB/expired_certs";
push @dbList, "$DIR/dB/suspended_certs";

push @dbList, "$DIR/dB/pending_reqs";
push @dbList, "$DIR/dB/approved_reqs";
push @dbList, "$DIR/dB/deleted_reqs";
push @dbList, "$DIR/dB/renew_reqs";

push @dbList, "$DIR/dB/archivied_crls";

if ( $SERVER =~ /CA/ ) {
	push @dbList, "$DIR/dB/archivied_reqs";
}

foreach $DB_FILE (@dbList) {
	dbmopen( %CERT_DB, "$DB_FILE", 0600 ) || die "Error: $DB_FILE!";
	##	$CERT_DB{0} = "";
	dbmclose( %CERT_DB );
}

exit;
